<?php
    class MYPDF extends TCPDF {
        public $pur=array(),$ticket=array(),$visa=array(),$delivery=array(),$customer=array(),$user=array(),$supplier=array(),$transfer=array();
        public $sReturn=array(),$pReturn=array(),$sq=array(),$rq=array(),$jMeta=array(),$company=array();
        public $c1w=10,$c2w=50,$c3w=55,$c4w=43,$c5w=28,$c6w=28,$c7w=45,$c8w=22,$visaPageMaxY=230,$leftMargin=10,$sqMaxY=260;
        public function setPurchaseVar($pur){$this->pur=$pur;}
        public function setCompanyVar($company){$this->company=$company;}
        public function setVisaVar($v){$this->visa=$v;}
        public function setTicketVar($v){$this->ticket=$v;}
        public function setCustomerVar($customer){$this->customer=$customer;}
        public function setUserVar($user){$this->user=$user;}
        //Page header
        public function Header() {
            $general=new General();
            if(!isset($_GET['pad'])){
                if($_SERVER['SERVER_NAME']==LOCAL_SERVER_NAME){$imSrc='images';}
                else{$imSrc=ROOT_PATH.'/images';}
                $this->Image($imSrc.'/logo.jpg',$this->leftMargin,8.5,60,12,'JPEG');
                $img=$imSrc.'/plogo1.jpg';
                $aW=7;
                $aH=7;
                if(file_exists($img)){
                    $this->Image($img,164,8.5,30,7,'JPEG');
                }
                $img=$imSrc.'/plogo2.jpg';
                if(file_exists($img)){
                    $this->Image($imSrc.'/plogo2.jpg',150,8.5,8,8,'JPEG');
                }
                $img=$imSrc.'/plogo3.jpg';
                if(file_exists($img)){
                    list($imgW, $imgH) = getimagesize($img);
                    $imgS=$general->imageRation($imgW,$imgH,$aW,$aH);
                    $this->Image($imSrc.'/plogo3.jpg',120.5,8.5,0,0,'JPEG');
                }
                $this->CreateTextBox($this->company['Address'],0,23.1,0,0,10.5,'B');
            }
        }

        public function CreateTextBox($textval, $x=0, $y, $width = 0, $height = 10, $fontsize = 8, $fontstyle = '', $align = 'L') {
            $this->SetXY($x+$this->leftMargin,$y); // 7 = margin left 
            $this->SetFont(INVOICE_FONT_NAME, $fontstyle, $fontsize);
            $this->Cell($width, $height, $textval, 0, false, $align);
        }
        public function CreateTextBoxForMultilink($txt,$y,$fontSize=10,$fontStyle='',$x=0){
            if($fontSize=='')$fontSize=10;
            $this->CreateTextBox($txt,$x,$y,80,10,$fontSize,$fontStyle);
        }

        public function saleInvoiceHeader($stY=50){
            $crm=new CRM();
            $fs=10;
            $this->CreateTextBoxForMultilink('Invoice To:',$stY,7,'B');
            $this->CreateTextBox($this->customer['cFastName'].' '.$this->customer['cLastName'],0,$stY+=4.2,80,10,$fs-2,'B');
            $this->SetFont(INVOICE_FONT_NAME,'',8);
            $stY+=8;
            $caTxt=str_ireplace('\r\n',"\n",$this->customer['cAddress']);
            $cHh=(strlen($caTxt)<50)?4:7;
            $this->MultiCell(87,$cHh,$caTxt,0,'L',false,1,$this->leftMargin,$stY);
            $stY+=$cHh;

            $this->MultiCell(87,0,$this->customer['cMobile'],0,'L',false,1,$this->leftMargin,$stY);
            $bw=31;$bh=9;

            $this->SetFont(INVOICE_FONT_NAME,'B',8);
            $x1=98;
            $x2=$x1+33;
            $x3=$x2+33;
            $y1=$stY-9.3;
            $y2=$y1+10;
            $yPosition=$stY-20;
            $yPosition+=15;
            $fy=$yPosition;
            $this->setCellPaddings(0, 0, 0, 0);
            $this->MultiCell($bw,$bh,'Invoice Date',1,'C','','',$x1,$y1);
            $this->MultiCell($bw,$bh,'Invoice ID',1,'C','','',$x2,$y1);
            $this->MultiCell($bw,$bh,'Pages',1,'C','','',$x3,$y1);
            $this->SetFont(INVOICE_FONT_NAME,'',8);
            $this->MultiCell($bw,2,date('d-M-y',$this->visa['createdOn']),0,'C',0,0,$x1,$y1+4);//Invoice Date
            $this->MultiCell($bw,2,'INV-'.$this->visa['viID'],0,'C',0,0,$x2,$y1+4);//Invoice ID
            $this->MultiCell(50,2,'Page '.$this->getAliasNumPage().'/'.$this->getAliasNbPages(),0,'C',0,0,$x3-1,$y1+4);

            $border=0;
            $y=$y1+20;
            return $y;
        }
        public function saleInvoiceTableHeader($cY){
            $cH=10;
            $cX=$this->leftMargin;
            $this->SetFont(INVOICE_FONT_NAME,'B',8);
            $this->setCellPaddings(2, 3, 2, 0);
            $this->MultiCell($this->c1w,$cH,'SL',1,'L',false,0,$cX,$cY);
            $cX+=$this->c1w;
            $this->MultiCell($this->c2w,$cH,'Name',1,'L','','',$cX,$cY);
            $cX+=$this->c2w;
            $this->MultiCell($this->c3w,$cH,'Passport No',1,'L','','',$cX,$cY);
            $cX+=$this->c3w;
            $this->MultiCell($this->c4w,$cH,'Category',1,'L','','',$cX,$cY);
            $cX+=$this->c4w;
            $this->MultiCell($this->c5w,$cH,'Amount',1,'R','','',$cX,$cY);

            $cY+=$cH;
            $this->SetFont(INVOICE_FONT_NAME,'',8);
            return $cY;
        }
        public function ticketInvoiceTableHeader($cY){
            $cH=10;
            $cX=$this->leftMargin;
            $this->SetFont(INVOICE_FONT_NAME,'B',8);
            $this->setCellPaddings(2, 3, 2, 0);
            $this->MultiCell($this->c1w,$cH,'SL',1,'L',false,0,$cX,$cY);
            $cX+=$this->c1w;
            $this->MultiCell($this->c2w,$cH,'Name',1,'L','','',$cX,$cY);
            $cX+=$this->c2w;
            $this->MultiCell($this->c3w,$cH,'Ticket No',1,'L','','',$cX,$cY);
            $cX+=$this->c3w;
            $this->MultiCell($this->c8w,$cH,'Date',1,'L','','',$cX,$cY);
            $cX+=$this->c8w;
            $this->MultiCell($this->c5w,$cH,'Route',1,'L','','',$cX,$cY);
            $cX+=$this->c5w;
            $this->MultiCell($this->c6w,$cH,'Amount',1,'R','','',$cX,$cY);

            $cY+=$cH;
            $this->SetFont(INVOICE_FONT_NAME,'',8);
            return $cY;
        }
        public function saleInvoiceLastRow($cY){
            $c1w=$this->c1w;$c2w=$this->c2w;$c3w=$this->c3w;$c4w=$this->c4w;$c5w=$this->c5w;$c6w=$this->c6w;
            //Last Row Start
            $totalWidth=$c1w+$c2w+$c3w+$c4w+$c5w+$c6w;
            $this->Line(7,$cY,$totalWidth+7,$cY,array('dash'=>0));
            $this->SetLineStyle(array('dash'=>0));
            $this->SetFont(INVOICE_FONT_NAME,'',9);
            $this->setCellPaddings(2,4,0,0);

            $cH=24;
            $cX=$this->leftMargin;
            $this->MultiCell($c1w,$cH,'','L','C','','',$cX,$cY);
            $cX+=$c1w;
            $this->MultiCell($c2w,$cH,'','L','C','','',$cX,$cY);
            $cX+=$c2w;
            $this->MultiCell($c3w,$cH,'Invoice Total','L','L','','',$cX,$cY);

            $this->Line($cX,$cY+$cH,$cX+$c3w,$cY+$cH,array('dash'=>2));
            $this->SetLineStyle(array('dash'=>0));
            $cX+=$c3w;
            $this->MultiCell($c4w,$cH,'','L','R','','',$cX,$cY);
            $cX+=$c4w;
            $scx=$cX;
            $this->MultiCell($c5w,$cH,'','L','R','','',$cX,$cY);
            $cX+=$c5w;
            $scx2=$cX;
            $this->MultiCell($c6w,$cH,'','LR','R','','',$cX,$cY);
            //Last Row sub Start
            $sH=5;
            $scw=$c5w-2;
            $this->SetFont(INVOICE_FONT_NAME,'',7);
            $this->setCellPaddings(0,0,0,0);
            $cY+=2;
            $this->MultiCell($c5w,$sH,'Sub Total: ',0,'R','','',$scx,$cY);
            $this->MultiCell($scw,$sH,$this->sale['total'],0,'R','','',$scx2,$cY);
            $cY+=$sH;
            $this->MultiCell($c5w,$sH,'Discount: ',0,'R','','',$scx,$cY);
            $this->MultiCell($scw,$sH,$this->sale['discount'],0,'R','','',$scx2,$cY);
            $cY+=$sH;
            $this->SetLineStyle(array('dash'=>2));
            $this->MultiCell($c5w,$sH,'VAT & TAX: ','B','R','','',$scx,$cY);
            $this->MultiCell($scw,$sH,number_format($this->sale['vat']+$this->sale['vat'],2),'B','R','','',$scx2,$cY);
            $cY+=$sH;
            $this->setCellPaddings(0,2,0,0);
            $sH+=1;
            $this->MultiCell($c5w,$sH,'Total: ',0,'R','','',$scx,$cY);
            $this->MultiCell($scw,$sH,$this->sale['netAmount'],0,'R','','',$scx2,$cY);
            $cY+=$sH+1;
            //Last Row sub End
            //Last Row End
            return $cY;


        }
        public function saleInvoiceFooter($cY,$pageTotal=0){
            $general=new General();
            $cX=$this->leftMargin;
            $c1w=$this->c1w;$c2w=$this->c2w;$c3w=$this->c3w;$c4w=$this->c4w;$c5w=$this->c5w;$c6w=$this->c6w;
            //page end row start
            $this->SetLineStyle(array('dash'=>0));
            $this->SetFont(INVOICE_FONT_NAME,'B',8);
            $this->setCellPaddings(0, 3, 0, 0);


            $cH=ceil($this->visaPageMaxY-$cY);
            if($cH>0){
                $this->MultiCell($c1w,$cH,'','LR','C',false,0,$cX,$cY, true, 0, false, true, 0, 'M');
                $cX+=$c1w;
                $this->MultiCell($c2w,$cH,'','R','C','','',$cX,$cY);
                $cX+=$c2w;
                $this->MultiCell($c3w,$cH,'','R','C','','',$cX,$cY);
                $cX+=$c3w;
                $this->MultiCell($c4w,$cH,'','R','C','','',$cX,$cY);
                $cX+=$c4w;
                $this->MultiCell($c5w,$cH,'','R','C','','',$cX,$cY);
                $cX+=$c5w;
                $this->MultiCell($c6w,$cH,'','R','C','','',$cX,$cY);

                $cY+=$cH;
            }
            $cH=7;

            $cX=$this->leftMargin;
            $cH=7;
            $this->setCellPaddings(3, 2, 3,0);
            $this->SetFont(INVOICE_FONT_NAME,'',7);
            $this->MultiCell($c1w,$cH,'','LR','C',false,0,$cX,$cY, true, 0, false, true, 0, 'M');
            $cX+=$c1w;
            $this->MultiCell($c2w,$cH,'','R','C','','',$cX,$cY);
            $cX+=$c2w;
            $this->MultiCell($c3w,$cH,'','R','C','','',$cX,$cY);
            $cX+=$c3w;
            $this->MultiCell($c4w,$cH,'Total Receivable','TR','R','','',$cX,$cY);
            $cX+=$c4w;
            $this->MultiCell($c5w,$cH,number_format($this->visa['viReceivable'],2),'TRB','R','','',$cX,$cY);
            $cY+=$cH;
            $cX=$this->leftMargin;

            $this->setCellPaddings(3, 2, 3,0);
            $this->SetFont(INVOICE_FONT_NAME,'',7);
            $this->MultiCell($c1w,$cH,'','LR','C',false,0,$cX,$cY, true, 0, false, true, 0, 'M');
            $cX+=$c1w;
            $this->MultiCell($c2w,$cH,'','R','C','','',$cX,$cY);
            $cX+=$c2w;
            $this->MultiCell($c3w,$cH,'','R','C','','',$cX,$cY);
            $cX+=$c3w;
            $this->MultiCell($c4w,$cH,'Paid','TR','R','','',$cX,$cY);
            $cX+=$c4w;
            $this->MultiCell($c5w,$cH,number_format($this->visa['viReceived'],2),'TRB','R','','',$cX,$cY);
            $cY+=$cH;
            $cX=$this->leftMargin;

            $this->setCellPaddings(3, 2, 3,0);
            $this->SetFont(INVOICE_FONT_NAME,'',7);
            $this->MultiCell($c1w,$cH,'','LBR','C',false,0,$cX,$cY, true, 0, false, true, 0, 'M');
            $cX+=$c1w;
            $this->MultiCell($c2w,$cH,'','RB','C','','',$cX,$cY);
            $cX+=$c2w;
            $this->MultiCell($c3w,$cH,'','RB','C','','',$cX,$cY);
            $cX+=$c3w;
            $this->SetFont(INVOICE_FONT_NAME,'B',8);
            $this->MultiCell($c4w,$cH,'Due','TRB','R','','',$cX,$cY);
            $cX+=$c4w;
            $this->MultiCell($c5w,$cH,number_format($this->visa['viDue'],2),'TRB','R','','',$cX,$cY);
            $cY+=$cH;
            //page end row end
            $cX=$this->leftMargin;
            $dw=$this->visa['viDue']>0?$general->convert_number_to_words($this->visa['viDue']):'Nill';

            $this->SetFont(INVOICE_FONT_NAME,'B',8);
            $this->MultiCell(0,$cH,'Due In Word : '.$dw,0,'L','','',$cX,$cY);
            $cY+=20;
            $this->SetFont(INVOICE_FONT_NAME,'',9);
            $this->MultiCell(50,$cH,'For A2Z Tour.','T','L','','',$this->leftMargin,$cY);
            $this->MultiCell(50,$cH,'Accounts Department','T','C','','',80,$cY);
            $this->MultiCell(50,$cH,'Customer Signature','T','R','','',145,$cY);
            $cY+=4;$this->MultiCell(50,$cH,$this->user['uFullName'],0,'L','','',$this->leftMargin,$cY);
            $cY+=4;$this->MultiCell(50,$cH,$this->user['uEmail'],0,'L','','',$this->leftMargin,$cY);
            $cY+=4;$this->MultiCell(50,$cH,$this->user['uMobile'],0,'L','','',$this->leftMargin,$cY);



            $this->SetFont(INVOICE_FONT_NAME,'',7);

            $cY=$this->visaPageMaxY+55;
            $this->pageFooter();
        }
        public function ticketInvoiceFooter($cY,$pageTotal=0){
            $general=new General();
            $cX=$this->leftMargin;
            $c1w=$this->c1w;$c2w=$this->c2w;$c3w=$this->c3w;$c4w=$this->c4w;$c5w=$this->c5w;$c6w=$this->c6w;
            $c8w=$this->c8w;
            //page end row start
            $this->SetLineStyle(array('dash'=>0));
            $this->SetFont(INVOICE_FONT_NAME,'B',8);
            $this->setCellPaddings(0, 3, 0, 0);


            $cH=ceil($this->visaPageMaxY-$cY);
            if($cH>0){
                $this->MultiCell($c1w,$cH,'','LR','C',false,0,$cX,$cY, true, 0, false, true, 0, 'M');
                $cX+=$c1w;
                $this->MultiCell($c2w,$cH,'','R','C','','',$cX,$cY);
                $cX+=$c2w;
                $this->MultiCell($c3w,$cH,'','R','C','','',$cX,$cY);
                $cX+=$c3w;
                $this->MultiCell($c8w,$cH,'','R','C','','',$cX,$cY);
                $cX+=$c8w;
               /* $this->MultiCell($c4w,$cH,'','R','C','','',$cX,$cY);
                $cX+=$c4w;*/
                $this->MultiCell($c5w,$cH,'','R','C','','',$cX,$cY);
                $cX+=$c5w;
                $this->MultiCell($c6w,$cH,'','R','C','','',$cX,$cY);

                $cY+=$cH;
            }
            $cH=7;

            $cX=$this->leftMargin;
            $cH=7;
            $this->setCellPaddings(3, 2, 3,0);
            $this->SetFont(INVOICE_FONT_NAME,'',7);
            $this->MultiCell($c1w,$cH,'','LR','C',false,0,$cX,$cY, true, 0, false, true, 0, 'M');
            $cX+=$c1w;
            $this->MultiCell($c2w,$cH,'','R','C','','',$cX,$cY);
            $cX+=$c2w;
            $this->MultiCell($c3w,$cH,'','R','C','','',$cX,$cY);
            $cX+=$c3w;
            $this->MultiCell($c8w,$cH,'','R','C','','',$cX,$cY);
            $cX+=$c8w;
            $this->MultiCell($c5w,$cH,'Receivable','TR','R','','',$cX,$cY);
            $cX+=$c5w;
            $this->MultiCell($c6w,$cH,number_format($this->ticket['tinBill'],2),'TRB','R','','',$cX,$cY);
            $cY+=$cH;
            $cX=$this->leftMargin;

            $this->setCellPaddings(3, 2, 3,0);
            $this->SetFont(INVOICE_FONT_NAME,'',7);
            $this->MultiCell($c1w,$cH,'','LR','C',false,0,$cX,$cY, true, 0, false, true, 0, 'M');
            $cX+=$c1w;
            $this->MultiCell($c2w,$cH,'','R','C','','',$cX,$cY);
            $cX+=$c2w;
            $this->MultiCell($c3w,$cH,'','R','C','','',$cX,$cY);
            $cX+=$c3w;
            $this->MultiCell($c8w,$cH,'','R','C','','',$cX,$cY);
            $cX+=$c8w;
            $this->MultiCell($c5w,$cH,'Paid','TR','R','','',$cX,$cY);
            $cX+=$c5w;
            $this->MultiCell($c6w,$cH,number_format($this->ticket['tinReceive'],2),'TRB','R','','',$cX,$cY);
            $cY+=$cH;
            $cX=$this->leftMargin;

            $this->setCellPaddings(3, 2, 3,0);
            $this->SetFont(INVOICE_FONT_NAME,'',7);
            $this->MultiCell($c1w,$cH,'','LBR','C',false,0,$cX,$cY, true, 0, false, true, 0, 'M');
            $cX+=$c1w;
            $this->MultiCell($c2w,$cH,'','RB','C','','',$cX,$cY);
            $cX+=$c2w;
            $this->MultiCell($c3w,$cH,'','RB','C','','',$cX,$cY);
            $cX+=$c3w;
            $this->MultiCell($c8w,$cH,'','RB','C','','',$cX,$cY);
            $cX+=$c8w;
            $this->SetFont(INVOICE_FONT_NAME,'B',8);
            $this->MultiCell($c5w,$cH,'Due','TRB','R','','',$cX,$cY);
            $cX+=$c5w;
            $this->MultiCell($c6w,$cH,number_format($this->ticket['tinDue'],2),'TRB','R','','',$cX,$cY);
            $cY+=$cH;
            //page end row end
            $cX=$this->leftMargin;
            $dw=$this->ticket['tinDue']>0?$general->convert_number_to_words($this->ticket['tinDue']):'Nill';

            $this->SetFont(INVOICE_FONT_NAME,'B',8);
            $this->MultiCell(0,$cH,'Due In Word : '.$dw,0,'L','','',$cX,$cY);
            $cY+=20;
            $this->SetFont(INVOICE_FONT_NAME,'',9);
            $this->MultiCell(50,$cH,'For A2Z Tour.','T','L','','',$this->leftMargin,$cY);
            $this->MultiCell(50,$cH,'Accounts Department','T','C','','',80,$cY);
            $this->MultiCell(50,$cH,'Customer Signature','T','R','','',145,$cY);
            $cY+=4;$this->MultiCell(50,$cH,$this->user['uFullName'],0,'L','','',$this->leftMargin,$cY);
            $cY+=4;$this->MultiCell(50,$cH,$this->user['uEmail'],0,'L','','',$this->leftMargin,$cY);
            $cY+=4;$this->MultiCell(50,$cH,$this->user['uMobile'],0,'L','','',$this->leftMargin,$cY);



            $this->SetFont(INVOICE_FONT_NAME,'',7);

            $cY=$this->visaPageMaxY+55;
            $this->pageFooter();
        }
        public function pageFooter(){
            $cY=$this->getPageHeight()-7;
            $this->SetFont(INVOICE_FONT_NAME,'',7);
            $this->setCellPaddings(0, 0, 0, 0);
            $this->MultiCell(80,0,'Printed from A2Z Tour, Date: '.date('d-M-Y, h:i:s A',TIME),0,'','','',$this->leftMargin,$cY);
            //            $this->SetFont(INVOICE_FONT_NAME,'',9);
            //            $this->MultiCell(50,5,'Page '.$this->getAliasNumPage().'/'.$this->getAliasNbPages(), 0,'L', false, 1, 182,$cY);
            $cY+=10;
        }
    }

?>
